//Marius Nicoli - CN Fratii Buzesti - Craiova
#include <stdio.h>
#define MOD 666013
#define DIM 1002

int di[8] = {0, 0, 1, -1, 1, -1, 1, -1};
int dj[8] = {1, -1, 1, -1, -1, 1,0, 0};

int A[DIM][DIM];
int B[DIM][DIM];
int C[2][DIM*DIM];

int N, M, i1, j1, i2, j2, ic, jc, iv, jv, ia, ja, k, d, D, stop, p, u;

int main(){
	FILE *g = fopen("rege.out", "w");
	FILE *f = fopen("rege.in", "r");
	fscanf(f,"%d %d %d %d %d %d", &N, &M, &i1, &j1, &i2, &j2);
	fclose(f);

	p = u = 1;
	C[0][1] = i1;
	C[1][1] = j1;
	A[i1][j1] = 1;
	B[i1][j1] = 1;
	stop = 0;
	while (p<=u && !stop) {
		ic = C[0][p];
		jc = C[1][p];
		D = A[ic][jc];
		for (d = 0;d<8;d++) {
			iv = ic + di[d];
			jv = jc + dj[d];
			if (iv>=1 && iv<=N && jv>=1 && jv<=M && A[iv][jv] == 0) {
				u++;
				C[0][u] = iv;
				C[1][u] = jv;
				A[iv][jv] = A[ic][jc] + 1;
				for (k = 0; k<8; k++) {
					ia = iv + di[k];
					ja = jv + dj[k];
					if (ia>=1 && ia<=N && ja>=1 && ja<=M && (A[ia][ja] == A[iv][jv] - 1)) {
						B[iv][jv] += B[ia][ja];
						if (B[iv][jv] >= MOD)
							B[iv][jv] -= MOD;
					}
				}
				if (iv == i2 && jv == j2) {
					stop = 1;
				}
			}
		}
		p++;
	}
	fprintf(g,"%d",B[i2][j2]);
	fclose(g);
	return 0;
}
